//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <assert.h>
#define	ASSERT	assert

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BRFileTree"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
	HRESULT	hr;
	IShellFolder	*p_desktop;
	LPITEMIDLIST	pidl;
	LPMALLOC		pmalloc;
	char			szPath[MAX_PATH];

	hr = ::SHGetMalloc(&pmalloc);
	ASSERT(hr == NOERROR);
	hr = ::SHGetSpecialFolderLocation(NULL, CSIDL_PERSONAL, &pidl);
	ASSERT(hr == NOERROR);
	BRFileTree1->AddTopItem("", pidl);

	pmalloc->Free(pidl);
	pmalloc->Release();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	HRESULT	hr;
	IShellFolder	*p_desktop;
	LPITEMIDLIST	pidl;
	LPMALLOC		pmalloc;
	char			szPath[MAX_PATH];

	BRFileTree2->EnumMask = SHCONTF_FOLDERS | SHCONTF_INCLUDEHIDDEN | SHCONTF_NONFOLDERS;
	hr = ::SHGetMalloc(&pmalloc);
	ASSERT(hr == NOERROR);
	hr = ::SHGetSpecialFolderLocation(NULL, CSIDL_DRIVES, &pidl);
	ASSERT(hr == NOERROR);
	BRFileTree2->AddTopItem("", pidl);

	pmalloc->Free(pidl);
	pmalloc->Release();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BRFileTree1AddItem(TObject *Sender,
	  TTreeNode *Node, bool &f_ok)
{
	TBRFileInfo	*p_info;
	String		as_line;
	String		as_path;
	String		as_name;
	bool		f_folder;

	p_info = (TBRFileInfo*)Node->Data;
	if(p_info)
	{
		as_path = p_info->PathName;
		as_name = p_info->DisplayName;
		f_folder = (p_info->Attribute & SFGAO_FOLDER) != 0;

		as_line = (String)"Name is " + as_name;
		if(!as_path.IsEmpty())
		{
			as_line += (String)" Path is " + as_path;
		}
		else
		{
			as_line += (String)" Path is nathing";
		}
		if(f_folder)
		{
			as_line += (String)" Type Folder.";
		}
		else
		{
			as_line += (String)" Type Non Folder.";
		}
		Memo1->Lines->Add(as_line);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BRFileTree2AddItem(TObject *Sender,
	  TTreeNode *Node, bool &f_ok)
{
	TBRFileInfo	*p_info;
	String		as_line;
	String		as_path;
	String		as_name;
	bool		f_folder;

	p_info = (TBRFileInfo*)Node->Data;
	if(p_info)
	{
		as_path = p_info->PathName;
		as_name = p_info->DisplayName;
		f_folder = (p_info->Attribute & SFGAO_FOLDER) != 0;

		as_line = (String)"Name is " + as_name;
		if(!as_path.IsEmpty())
		{
			as_line += (String)" Path is " + as_path;
		}
		else
		{
			as_line += (String)" Path is nathing";
		}
		if(f_folder)
		{
			as_line += (String)" Type Folder.";
		}
		else
		{
			as_line += (String)" Type Non Folder.";
		}
		Memo2->Lines->Add(as_line);
	}
}
//---------------------------------------------------------------------------
// Filteredg킸ɓl̏
// FilterExt͂ЂƂ̊gqwłAChJ[hwȂǂ
// sȂ̂ŁAKvȏꍇ͂ȊœƎ
// f_okԂĂB
#if	0
void __fastcall TForm1::BRFileTree2AddItem(TObject *Sender,
	  TTreeNode *Node, bool &f_ok)
{
	TBRFileInfo	*p_info;
	String		as_line;
	String		as_path;
	String		as_name;
	bool		f_folder;

	p_info = (TBRFileInfo*)Node->Data;
	if(p_info)
	{
		if(!(p_info->Attribute & SFGAO_FOLDER) &&
			AnsiCompareText(ExtractFileExt(p_info->PathName), ".txt") &&
			AnsiCompareText(ExtractFileExt(p_info->DisplayName), ".txt"))
		{
			f_ok = false;
			return;
		}

		as_path = p_info->PathName;
		as_name = p_info->DisplayName;
		f_folder = (p_info->Attribute & SFGAO_FOLDER) != 0;

		as_line = (String)"Name is " + as_name;
		if(!as_path.IsEmpty())
		{
			as_line += (String)" Path is " + as_path;
		}
		else
		{
			as_line += (String)" Path is nathing";
		}
		if(f_folder)
		{
			as_line += (String)" Type Folder.";
		}
		else
		{
			as_line += (String)" Type Non Folder.";
		}
		Memo2->Lines->Add(as_line);
	}
}
#endif

